package com.yunyan.common.exception;

/**
 * ERP 业务异常
 * 
 * @author yunyan
 */
public final class ErpCrmException extends RuntimeException
{
    private static final long serialVersionUID = 1L;

    /**
     * 错误码
     */
    private Integer code;

    /**
     * 错误提示
     */
    private String message;

    /**
     * 错误明细，内部调试错误
     *
     * 和 {@link CommonResult#getDetailMessage()} 一致的设计
     */
    private String detailMessage;

    /**
     * 空构造方法，避免反序列化问题
     */
    public ErpCrmException()
    {
    }

    public ErpCrmException(String message)
    {
        this.message = message;
    }

    public ErpCrmException(String message, Integer code)
    {
        this.message = message;
        this.code = code;
    }

    public String getDetailMessage()
    {
        return detailMessage;
    }

    @Override
    public String getMessage()
    {
        return message;
    }

    public Integer getCode()
    {
        return code;
    }

    public ErpCrmException setMessage(String message)
    {
        this.message = message;
        return this;
    }

    public ErpCrmException setDetailMessage(String detailMessage)
    {
        this.detailMessage = detailMessage;
        return this;
    }
}